!function(){
	var Donut3D={};
	
	var PreviousSelection = -1;
	var IsOnClickEvent = false;
	
	function pieTop(d, rx, ry, ir ){
		if(d.endAngle - d.startAngle == 0 ) return "M 0 0";

		var sx = rx*Math.cos(d.startAngle),
			sy = ry*Math.sin(d.startAngle),
			ex = rx*Math.cos(d.endAngle),
			ey = ry*Math.sin(d.endAngle);

			
		var ret =[];
		ret.push("M",sx,sy,"A",rx,ry,"0",(d.endAngle-d.startAngle > Math.PI? 1: 0),"1",ex,ey,"L",ir*ex,ir*ey);
		ret.push("A",ir*rx,ir*ry,"0",(d.endAngle-d.startAngle > Math.PI? 1: 0), "0",ir*sx,ir*sy,"z");
		return ret.join(" ");
	}

	function pieOuter(d, rx, ry, h ){
		var startAngle = (d.startAngle > Math.PI ? Math.PI : d.startAngle);
		var endAngle = (d.endAngle > Math.PI ? Math.PI : d.endAngle);
		
		var sx = rx*Math.cos(startAngle),
			sy = ry*Math.sin(startAngle),
			ex = rx*Math.cos(endAngle),
			ey = ry*Math.sin(endAngle);
			
			var ret =[];
			ret.push("M",sx,h+sy,"A",rx,ry,"0 0 1",ex,h+ey,"L",ex,ey,"A",rx,ry,"0 0 0",sx,sy,"z");
			return ret.join(" ");
	}

	function pieInner(d, rx, ry, h, ir ){
		var startAngle = (d.startAngle < Math.PI ? Math.PI : d.startAngle);
		var endAngle = (d.endAngle < Math.PI ? Math.PI : d.endAngle);
		
		var sx = ir*rx*Math.cos(startAngle),
			sy = ir*ry*Math.sin(startAngle),
			ex = ir*rx*Math.cos(endAngle),
			ey = ir*ry*Math.sin(endAngle);

			var ret =[];
			ret.push("M",sx, sy,"A",ir*rx,ir*ry,"0 0 1",ex,ey, "L",ex,h+ey,"A",ir*rx, ir*ry,"0 0 0",sx,h+sy,"z");
			return ret.join(" ");
	}

	function getPercent(d){
		
		return (Math.round(1000*(d.data.percent))/10)+'%';
		//return (d.endAngle-d.startAngle > 0.2 ? Math.round(1000*(d.endAngle-d.startAngle)/(Math.PI*2))/10+'%' : '');
	}	
	

	
	Donut3D.transition = function(id, data, rx, ry, h, ir, style){
		function arcTweenInner(a) {
		  var i = d3.interpolate(this._current, a);
		  this._current = i(0);
		  return function(t) { return pieInner(i(t), rx+0.5, ry+0.5, h, ir);  };
		}
		function arcTweenTop(a) {
		  var i = d3.interpolate(this._current, a);
		  this._current = i(0);
		  return function(t) { return pieTop(i(t), rx, ry, ir);  };
		}
		function arcTweenOuter(a) {
		  var i = d3.interpolate(this._current, a);
		  this._current = i(0);
		  return function(t) { return pieOuter(i(t), rx-.5, ry-.5, h);  };
		}
		function textTweenX(a) {
		  var i = d3.interpolate(this._current, a);
		  this._current = i(0);
		  return function(t) { 
				//return 0.6*rx*Math.cos(0.5*(i(t).startAngle+i(t).endAngle));  
				return Math.cos(i(t).startAngle + (i(t).endAngle - i(t).startAngle)/2) * (rx - 40);  
			};
		}
		function textTweenY(a) {
		  var i = d3.interpolate(this._current, a);
		  this._current = i(0);
		  return function(t) { 
				//return 0.6*rx*Math.sin(0.5*(i(t).startAngle+i(t).endAngle));  
				return Math.sin(i(t).startAngle + (i(t).endAngle - i(t).startAngle)/2) * (ry - 30);  
			};
		}

		// Draw the lines from each arc outward, the color of each line will be based on the color of the arc
		function updateLabelLines() {
			var polyline = d3.select("#"+id).selectAll(".polyline").data(_data);
			
			polyline.enter().append("polyline")
			.transition()
			.duration(100)
			.style("stroke", function(d) { return d3.hsl(d.data.color).darker(2); })
			.attrTween("points", function(d) {
				
				this._current = this._current || d;	
				var interpolate = d3.interpolate(this._current, d);
				this._current = interpolate(0);
				
				return function(t) {

					var y  = ry*2 + 10 + Math.sin(interpolate(t).startAngle + (interpolate(t).endAngle - interpolate(t).startAngle)/2) * (ry + 50);
					var x  = rx*2 + Math.cos(interpolate(t).startAngle + (interpolate(t).endAngle - interpolate(t).startAngle)/2) * (rx + 50);  
					var y1 = ry*2 + 10 + Math.sin(interpolate(t).startAngle + (interpolate(t).endAngle - interpolate(t).startAngle)/2) * (ry);
					var x1 = rx*2 + Math.cos(interpolate(t).startAngle + (interpolate(t).endAngle - interpolate(t).startAngle)/2) * (rx);  
			   
					return [x,y,x1,y1];
			  };
			});

		  polyline.exit()
			.remove();
		}
		
		// Draw the text next to each line
		function updateLabelsText() {
			
			labelr = rx + 40 // radius for label anchor
			
			var slices = d3.select("#"+id).selectAll(".TextLabel").data(_data);
			
			slices.enter().append("text")			
				.transition()
				.duration(120)
				.attr("dy", ".35em")
				.attr("x", function(d) { return rx*2 + Math.cos(d.startAngle + (d.endAngle - d.startAngle)/2) * (rx + 60);})
				.attr("y", function(d) { return ry*2 + 10 + Math.sin(d.startAngle + (d.endAngle - d.startAngle)/2) * (ry + 60);})
				.attr("text-anchor", function(d) {
					// are we past the center?
					arcAngle = (d.startAngle + (d.endAngle - d.startAngle)) / 2;
					
					return  ((arcAngle > 0) && (arcAngle <= (0.25 * Math.PI))) || ((arcAngle > (0.75 * Math.PI)) && (arcAngle <= (1.1 * Math.PI)))  ? "start" : "end";
				})
				.text(function(d) {	
					arcAngle = (d.startAngle + (d.endAngle - d.startAngle)) / 2;
					return d.data.label
				}
				);
		}
		
		function updateLabelsValue() {
			
			labelr = rx + 40 // radius for label anchor
			
			var slices = d3.select("#"+id).selectAll(".TextValue").data(_data);
			
			slices.enter().append("text")			
				.transition()
				.duration(120)
				.attr("dy", ".35em")
				.attr("x", function(d) { return rx*2 + Math.cos(d.startAngle + (d.endAngle - d.startAngle)/2) * (rx + 60);})
				.attr("y", function(d) { return 20 + ry*2 + 10 + Math.sin(d.startAngle + (d.endAngle - d.startAngle)/2) * (ry + 60);})
				.attr("text-anchor", function(d) {
					// are we past the center?
					arcAngle = (d.startAngle + (d.endAngle - d.startAngle)) / 2;
					
					return  ((arcAngle > 0) && (arcAngle <= (0.25 * Math.PI))) || ((arcAngle > (0.75 * Math.PI)) && (arcAngle <= (1.1 * Math.PI)))  ? "start" : "end";
				})
				.text(function(d) {	
					arcAngle = (d.startAngle + (d.endAngle - d.startAngle)) / 2;
					return d.data.formattedtext 
				}
				);
		}
		
		//if (IsOnClickEvent){
	//		IsOnClickEvent = false;
//			return;
		//};
		
		var _data = d3.layout.pie()
				.sort(null)
				.padAngle(5)
				.value(function(d) {return d.value;})(data);

		
		d3.select("#"+id).selectAll(".innerSlice").data(_data)
			.transition().duration(750).attrTween("d", arcTweenInner); 
			
		d3.select("#"+id).selectAll(".topSlice").data(_data)
			.transition().duration(750).attrTween("d", arcTweenTop); 
			
		d3.select("#"+id).selectAll(".outerSlice").data(_data)
			.transition().duration(750).attrTween("d", arcTweenOuter); 	
		if (style.LabelsEnabled){
			if (style.ShowPercent)
			{
				d3.select("#"+id).selectAll(".percent").data(_data).transition().duration(750)
					.attrTween("x",textTweenX).attrTween("y",textTweenY)
					.text(getPercent); 	
			};
			
			if (style.ShowCategories ||  style.ShowValue)
			{
				updateLabelLines();
				if (style.ShowCategories)
				{
					updateLabelsText();
				}
				if (style.ShowValue)
				{
					updateLabelsValue();
				}
			}
		}
		
	}
	
	Donut3D.draw=function(id, data, x /*center x*/, y/*center y*/, 
			rx/*radius x*/, ry/*radius y*/, h/*height*/, ir/*inner radius*/){
	
		// Define the div for the tooltip
		var div = d3.select("body").append("div").attr("class", "toolTip");		
		debugger;
		var _data = d3.layout.pie()
				.sort(null)
				//.startAngle(-90 * Math.PI/180)
				//.endAngle(-90 * Math.PI/180 + 2*Math.PI)
				.padAngle(5)
				.value(function(d) {return d.value;})(data)	;


		
		var slices = d3.select("#"+id).append("g").attr("transform", "translate(" + x + "," + y + ")").attr("class", "slices");
		
		
		SelectedSlice = null;
			
		// Add Stroke attribute to add padding to each slice
		slices.selectAll(".innerSlice").data(_data).enter().append("path").attr("class", "innerSlice")
			.style("fill", function(d) { return d3.hsl(d.data.color).darker(1) })
			.style("fill-opacity",function(SliceData){ return SliceData.data.DashboardFiltered ? null: 0.2})  
			.attr("id",function(d) { return d.id; } )
			.attr("stroke","white")
			.attr("stroke-width",5)
			.attr("d",function(d){ return pieInner(d, rx+0.5,ry+0.5, h, ir);})
			.each(function(d){this._current=d;});
		// Draw the Top part of each slice
		slices.selectAll(".topSlice").data(_data).enter().append("path").attr("class", "topSlice")
			.style("fill", function(d) { return d3.hsl(d.data.color).darker(1) })
			.style("fill-opacity",function(SliceData){ return SliceData.data.DashboardFiltered ? null: 0.2})  
			.attr("stroke","white")
			.attr("id",function(d) { return d.id; } )
			.attr("stroke-width",5)
			.attr("d",function(d){ return pieTop(d, rx, ry, ir);})
			.each(function(d){this._current=d;})
			// Hook up the click event
			.on("click", function(d,index) {
					IsOnClickEvent = true;
			
					
					if (PreviousSelection != d.data.id){
						
						//	Create a jaql statement for this item
						currentJAQL = d.data.WidgetObject.metadata.panels[0].items[0].jaql;
						var filterJaql = {
			        		jaql: {
			        			dim: currentJAQL.dim,
			        			title: currentJAQL.Title,
			        			datatype: currentJAQL.datatype,
			        			filter: {
			        				members:[d.data.label]
			        			}
			        		}
			        	};
						//	Create the filter's options
						var filterOptions = {
							save: true,
							refresh: true,
							unionIfSameDimensionAndSameType: false
						};					
						
						//	Set the filter	
						prism.activeDashboard.filters.update(filterJaql,filterOptions);		

						PreviousSelection = d.data.id;						
					}
					else {
						//	Create a jaql statement for this item
						currentJAQL = d.data.WidgetObject.metadata.panels[0].items[0].jaql;
						var filterJaql = {
			        		jaql: {
			        			dim: currentJAQL.dim,
			        			title: currentJAQL.Title,
			        			datatype: currentJAQL.datatype,
			        			filter: {all: true}
			        		}
			        	};
						//	Create the filter's options
						var filterOptions = {
							save: true,
							refresh: true,
							unionIfSameDimensionAndSameType: false
						};					
						
						//	Set the filter	
						prism.activeDashboard.filters.update(filterJaql,filterOptions);		

						PreviousSelection = -1;
					};

					div.style("display", "none");
					
			})
			.on("mouseover", function(d) {	
				percentValue = d.endAngle-d.startAngle > 0.2 ? Math.round(1000*(d.endAngle-d.startAngle)/(Math.PI*2))/10+'%':'';
				
				div.style("left", d3.event.pageX+10+"px");
				div.style("top", d3.event.pageY-25+"px");
				div.style("display", "inline-block");
				div.html((d.data.label)+"<br><br>" + (d.data.ValueLabelText) + " : " +  (d.data.formattedtext) + " [" + percentValue + "]");	})
			.on("mouseout", function(d) {		
				div.style("display", "none");
				});
		
		// Draw the Outer part of each slice
		slices.selectAll(".outerSlice").data(_data).enter().append("path").attr("class", "outerSlice")
			.style("fill", function(d) { return d3.hsl(d.data.color).darker(1) })
			.style("fill-opacity",function(SliceData){ return SliceData.data.DashboardFiltered ? null: 0.2})  
			//.style("fill", function(d) { return d3.hsl(d.data.color).darker(0.7); })
			.attr("stroke","white")
			.attr("stroke-width",5)
			.attr("id",function(d) { return d.id; } )
			.attr("d",function(d){ return pieOuter(d, rx-.5,ry-.5, h);})
			.each(function(d){this._current=d;});
		
			//slices.selectAll(".percent").data(_data).enter().append("text").attr("class", "percent")
				//.attr("x",function(d){ return y + Math.cos(d.startAngle + (d.endAngle-d.startAngle))*200;})
				//.attr("y",function(d){ return x + Math.sin(d.startAngle + (d.endAngle-d.startAngle))*200;})
				//.text("");
				//.text(getPercent).each(function(d){this._current=d;});		
			//	.text(getPercent).each(function(d){this._current=d;});		
			slices.selectAll(".percent").data(_data).enter().append("text").attr("class", "percent")
				.attr("x",-10000)
				.attr("y",-10000)
				.text(getPercent).each(function(d){this._current=d;});		
	}
	
	this.Donut3D = Donut3D;
	
}();